//---------------------------------------------------------------------------

#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <ComCtrls.hpp>


#include <itkImage.h>
#include <itkImageIterator.h>
#include <itkImageFileReader.h>
#include <itkImageFileWriter.h>
#include <itkPNGImageIO.h>
#include <itkBinaryThresholdImageFilter.h>
#include "itkRescaleIntensityImageFilter.h"
#include "itkDanielssonDistanceMapImageFilter.h"
#include "itkMinimumMaximumImageCalculator.h"
#include <itkCastImageFilter.h>
#include "itkResampleImageFilter.h"
#include "itkAffineTransform.h"
#include "itkNearestNeighborInterpolateImageFunction.h"

typedef  unsigned char   InputPixelType;
typedef  unsigned short  OutputPixelType;

typedef unsigned char   PixelType;
typedef itk::RGBPixel< unsigned char >  RGBPixelType;
typedef itk::Image< PixelType, 2 >   ImageType;
typedef itk::Image< PixelType, 2 > OutputImageType;

typedef itk::ImageFileReader<ImageType> ImageReaderType;
typedef itk::BinaryThresholdImageFilter<ImageType, ImageType>  ThresholdFilterType;
typedef itk::DanielssonDistanceMapImageFilter< ImageType, ImageType >  FilterType;
typedef itk::RescaleIntensityImageFilter< ImageType, ImageType > RescalerType;
typedef itk::CastImageFilter< ImageType, OutputImageType > CastType;
typedef itk::ImageFileWriter< ImageType >  WriterType;
typedef itk::ImageFileWriter<ImageType> ImageWriterType;
typedef itk::ImageRegionIterator<OutputImageType> IteratorType;

typedef itk::NearestNeighborInterpolateImageFunction< ImageType, double >  InterpolatorType;
typedef itk::AffineTransform< double, 2 >  TransformType;
typedef itk::ResampleImageFilter< ImageType, ImageType >  ResampleType;

const int Dimension = 2;

//---------------------------------------------------------------------------
class TFormPrincipal : public TForm
{
__published:	// IDE-managed Components
	TButton *Salir;
	TButton *Danielsson;
	TImage *ImagenVisual;
	void __fastcall SalirClick(TObject *Sender);
	void __fastcall DanielssonClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall FormCreate(TObject *Sender);
private:	// User declarations
public:		// User declarations
	__fastcall TFormPrincipal(TComponent* Owner);
        __fastcall ~TFormPrincipal();

        ImageReaderType::Pointer reader;
        ThresholdFilterType::Pointer binario;
        FilterType::Pointer filter;
        RescalerType::Pointer scaler;
        CastType::Pointer caster;
        ImageWriterType::Pointer writer;
        WriterType::Pointer scalerwriter;
        InterpolatorType::Pointer interpolator;
        TransformType::Pointer transform;
        ResampleType::Pointer resample;
        IteratorType  *it;
        int Umbral;
        ImageType::SizeType size;
};

//---------------------------------------------------------------------------
extern PACKAGE TFormPrincipal *FormPrincipal;
//---------------------------------------------------------------------------
#endif
